<?php

/*
*
* WP Licensing system Plugin WordPress
* It doesn't work witout WP Licensing System Installed On your Wordpress Blog
* File Name: _hook_.php
* All Right reserved by law, You're not authorized to modified, edit, or distribute without right!
* (c) WPDeveloper, CV. 2013
*
*/

if (!defined('ABSPATH')){
	header("HTTP/1.0 404 Not Found");
	exit('<h1>Not Found</h1>The requested URL '.$_SERVER['SCRIPT_NAME'].' was not found on this server.'); //Exit if accessed directly
}
/*****************HOOK FUNCTIONS*********************/

function wp_licensing_sys_admin_menu() {

	global $wpdb;
	$num_order_pending = $wpdb->get_var("SELECT COUNT(id) AS total FROM {$wpdb->prefix}licensing WHERE status = 3 AND (expire > ".time()." OR expire = 0)");
	$num_pending = "<span class='update-plugins count-$num_order_pending'><span class='plugin-count'>" . number_format_i18n($num_order_pending) . '</span></span>';

    add_menu_page("WordPress Licensing System", "Licensing System", "manage_options", 'wp_licensing_manager', 'wls_admin_dashboard', LICENSEMANAGER_LOCATION.'/asset/icon.png', '56.0');
	add_submenu_page("wp_licensing_manager", "Dashboard WordPress Licensing System", "Licensing Dashboard", "manage_options", "wp_licensing_manager", "wls_admin_dashboard");
	
	if(wls_serial_valid()){
		add_submenu_page("wp_licensing_manager", "WP Licensing System Product Manager", "Product Manager", "manage_options", "wp_licensing_product", "wp_licensing_product");
		add_submenu_page("wp_licensing_manager", "WP Licensing System Transaction", "Transaction History", "manage_options", "order_history", "wls_order_stats");
		add_submenu_page("wp_licensing_manager", "WP Licensing System Order Pending", "Pending Licenses {$num_pending}", "manage_options", "wp_licensing_order_pending", "wp_licensing_order_pending");
		add_submenu_page("wp_licensing_manager", "WP Licensing System Generate Key", "Generate New Key", "manage_options", "wp_licensing_generate_key", "wp_licensing_generate_key");
		add_submenu_page("wp_licensing_manager", "WP Licensing System Setting", "Settings", "manage_options", "wp_licensing_admin_setting", "wp_licensing_admin_setting");	
	}
	
    add_submenu_page("wp_licensing_manager", "WP Licensing System License", "License", "manage_options", "wls_license", "wls_license");
    //add_submenu_page("wp_licensing_manager", "About WP Licensing System", "About", "manage_license", "wls_about", "wls_about");
	add_submenu_page("wpls_doinstall", "Licensing System Install Required Plugin", "", "manage_options", "wpls_doinstall", "wpls_plugin_install_page");
}

add_action(wpls_multisite().'wp_dashboard_setup', 'wp_lic_main_dashboard_widgets');
add_action(wpls_multisite().'admin_bar_menu', 'wp_licensing_sys_admin_bar');
add_action(wpls_multisite().'admin_menu', 'wp_licensing_sys_admin_menu');
add_action('wp_dashboard_setup', 'wp_lic_main_dashboard_widgets');
add_action('admin_bar_menu', 'wp_licensing_sys_admin_bar');
add_action('admin_menu', 'wp_licensing_sys_admin_menu');
add_action('admin_init', 'wls_caps');

function wls_caps() {
	$role = get_role( 'administrator' );
	$role->add_cap( 'manage_license' );
}

function wp_licensing_sys_admin_bar() {
	global $wpdb;

	$num_order_pending = $wpdb->get_var("SELECT COUNT(id) AS total FROM {$wpdb->prefix}licensing WHERE status = 3 AND (expire > ".time()." OR expire = 0)");
	$num_pending = "<span class='update-plugins count-$num_order_pending'><span class='plugin-count'>" . number_format_i18n($num_order_pending) . '</span></span>';
}

add_action('admin_init', 'wpls_action');
function wpls_action() {
	if(isset($_REQUEST['wpls_action']) && $_REQUEST['wpls_action'] == 'install'){
		$status = wp_licensing_install();
		if($status){
			echo '<div class="updated"><p>Your Wordpress Licensing System is ready!</p></div>';
		}
	}
}

function wp_licensing_install() { 
	global $wp_licensing_version, $table_prefix, $wpdb, $license_status, $license_activities;
	$wp_licensing_version = LICENSEMANAGER_VERSION;
	$installed_ver  = get_wpls_option('wls_version');
	$lic  = get_wpls_option('wls_license');

	//require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}licensing` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `license` tinytext CHARACTER SET utf8 NOT NULL,
	  `domain` tinytext CHARACTER SET utf8 NOT NULL,
	  `expire` text CHARACTER SET utf8 NOT NULL,
	  `status` tinyint(4) NOT NULL DEFAULT '3',
	  `product` tinytext CHARACTER SET utf8 NOT NULL,
	  `add_on` int(11) NOT NULL,
	  `validip` tinytext CHARACTER SET utf8 NOT NULL,
	  `order_id` tinytext CHARACTER SET utf8 NOT NULL,
	  `userid` int(11) NOT NULL,
	  `envato_key` tinytext CHARACTER SET utf8 NOT NULL,
	  `type` text CHARACTER SET utf8 NOT NULL,
	  `allowed` int(4) NOT NULL DEFAULT '1',
	  `mproduct` varchar(11) NOT NULL DEFAULT 'no',
	  `invoice` text CHARACTER SET utf8 NOT NULL,
	  `pro_code` text NOT NULL,
	  PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
	$wpdb->query($sql);
	
	$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}licensing_setting` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `dbhost` text CHARACTER SET utf8 NOT NULL,
	  `dbname` text CHARACTER SET utf8 NOT NULL,
	  `dbuser` text CHARACTER SET utf8 NOT NULL,
	  `dbpass` text CHARACTER SET utf8 NOT NULL,
	  `dbtable` text CHARACTER SET utf8 NOT NULL,
	  `pre_key` text CHARACTER SET utf8 NOT NULL,
	  `post_key` text CHARACTER SET utf8 NOT NULL,
	  `key_cunk` text CHARACTER SET utf8 NOT NULL,
	  `key_part` text CHARACTER SET utf8 NOT NULL,
	  `key_store` text CHARACTER SET utf8 NOT NULL,
	  `key_uniq` text CHARACTER SET utf8 NOT NULL,
	  `key_split` text CHARACTER SET utf8 NOT NULL,
	  `key_div` text CHARACTER SET utf8 NOT NULL,
	  `blogurl` text CHARACTER SET utf8 NOT NULL,
	  `int_woocom` int(11) NOT NULL,
	  `reissue` int(11) NOT NULL,
	  `dexpire` tinytext NOT NULL,
	  `lic_expire` int(11) NOT NULL DEFAULT '1',
	  `int_jigo` int(11) NOT NULL,
	  `int_wpsc` int(11) NOT NULL,
	  `type` tinytext NOT NULL,
	  `allowed` tinytext NOT NULL,
	  PRIMARY KEY (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2;";
	$wpdb->query($sql);
	
	$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}licensing_user` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `email` tinytext CHARACTER SET utf8 NOT NULL,
	  `userid` int(11) NOT NULL,
	  `acc_on` int(11) NOT NULL,
	  `userip` tinytext CHARACTER SET utf8 NOT NULL,
	  `envato_key` tinytext CHARACTER SET utf8 NOT NULL,
	  PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;";
	$wpdb->query($sql);
	
	$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}licensing_items` (
	  `id` varchar(11) NOT NULL,
	  `product_name` tinytext NOT NULL,
	  `product_desc` longtext NOT NULL,
	  `allow` varchar(4) NOT NULL,
	  `type` text NOT NULL,
	  `product_price` varchar(11) NOT NULL DEFAULT '00.00',
	  `status` int(2) NOT NULL,
	  `mproduct` varchar(11) NOT NULL DEFAULT 'no',
	  `code` text NOT NULL,
	  PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;";
	$wpdb->query($sql);
	
	$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}licensing_orders` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `trans_product` text NOT NULL,
	  `trans_date` datetime NOT NULL,
	  `trans_type` text NOT NULL,
	  `trans_id` text NOT NULL,
	  `subscr_id` text NOT NULL,
	  `trans_amount` decimal(10,2) NOT NULL,
	  `trans_status` text NOT NULL,
	  `trans_currency` text NOT NULL,
	  `trans_payee_email` text NOT NULL,
	  `trans_payee_firstname` text NOT NULL,
	  `trans_payee_surname` text NOT NULL,
	  `issued` text NOT NULL,
	  `issuing_domain` text NOT NULL,
	  `invoice` text NOT NULL,
	  PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;";
	$wpdb->query($sql);
	
	$chks = $wpdb->get_var("SELECT COUNT(id) AS total FROM {$wpdb->prefix}licensing_setting WHERE id = '1'");
	if(!$chks){
		$wpdb->query("INSERT INTO `{$wpdb->prefix}licensing_setting` SET id = '1', dbtable = '{$wpdb->prefix}licensing', pre_key = 'licensed', post_key = '', key_cunk = '25', key_part = '1', key_store = 'TRUE',  key_uniq = 'TRUE', key_split = 'TRUE', key_div = '-', blogurl = '', int_woocom = '1', reissue = '0', dexpire = '1|7|30|90|180|365|0', lic_expire = '1', int_jigo = '0', int_wpsc = '0', type = 'Basic|Pro|Dev', allowed = '0|1|5|10'");
	}
	
	$licenseKey = (get_wpls_option('wls_license') <> '' ? get_wpls_option('wls_license') : 'UPDATE_YOUR_LICENSE');
	update_wpls_option( 'wls_license', $licenseKey );
	update_wpls_option( 'wls_destatus', '3' );
	update_wpls_option( 'envato_anable', 'not' );
	update_wpls_option( 'envato_lic_key', '' );
	update_wpls_option( 'envato_lic_time', '30' );
	update_wpls_option( 'envato_lic_page', '' );
	update_wpls_option( 'envato_lic_user', '' );
	update_wpls_option( 'wls_pp_email', 'hassan@noor.my.id' );
	update_wpls_option( 'wls_pp_sandbox', '' );
	update_wpls_option( 'wls_wc_autogen', 1 );	
	update_wpls_option( 'estore_lic_page', '' );
	
	if ($installed_ver < $wp_licensing_version) {
		if($installed_ver < "2.9.3"){
			$wpdb->query("ALTER TABLE `{$wpdb->prefix}licensing` ADD `mproduct` varchar(11) NOT NULL DEFAULT 'no';");
		}
		if($installed_ver < "2.9.4"){
			$wpdb->query("ALTER TABLE `{$wpdb->prefix}licensing` ADD `invoice` text NOT NULL;");
			$wpdb->query("ALTER TABLE `{$wpdb->prefix}licensing_orders` ADD `invoice` text NOT NULL;");
		}
		if($installed_ver < "2.9.8.6"){
			$wpdb->query("ALTER TABLE `{$wpdb->prefix}licensing` ADD `pro_code` text NOT NULL;");
			$wpdb->query("ALTER TABLE `{$wpdb->prefix}licensing_items` ADD `code` text NOT NULL;");
		}
	
		if($installed_ver < "2.9.9.1"){
			$cd_exist = $wpdb->query("SELECT column_name FROM INFORMATION_SCHEMA.columns WHERE table_name = `{$wpdb->prefix}licensing` AND column_name = 'pro_code'");
			if(!$cd_exist){
				$wpdb->query("ALTER TABLE `{$wpdb->prefix}licensing` ADD `pro_code` text NOT NULL;");
			}
		}
		
		if($installed_ver < "2.9.9.8"){
			$wpdb->query("UPDATE `{$wpdb->prefix}licensing_setting` SET dexpire = '3 Days|7 Days|1 Month|3 Months|6 Months|1 Year|0'");
		}
			
		update_wpls_option('wls_version', $wp_licensing_version);
		echo '<div class="updated"><p>Your WP Licensing System has been updated to '.$wp_licensing_version.'.</p></div>';
	}
	
	$config_licensing = file_get_contents(LICENSEMANAGER_PATH .'/config.class.php');
	$replace = array(
		"__HOSTNAME__" 	=> $wpdb->dbhost,
		"__DBNAME__" 	=> $wpdb->dbname,
		"__USERNAME__" 	=> $wpdb->dbuser,
		"__PASSWORD__" 	=> $wpdb->dbpassword,
		"__WLSTABLE__" 	=> $wpdb->prefix.'licensing'
		);
	$output	= str_replace(array_keys($replace), $replace, $config_licensing);
	$file = fopen(LICENSEMANAGER_PATH .'/config.class.php', 'w');
	fwrite($file, $output);
	fclose($file);
	
	return true;	
}

function _admin_notices_wpmu(){
	//echo '<div class="error"><p><strong>'.LICENSEMANAGER_NAME.':</strong> Sorry, '.LICENSEMANAGER_NAME.' does not support WPMU.</p></div>';
}
function _admin_notices_multisites(){
	echo '<div class="error"><p><strong>'.LICENSEMANAGER_NAME.':</strong> Sorry, '.LICENSEMANAGER_NAME.' does not support wordpress multisite.</p></div>';
}

function _is_wpmu() {
	return (
		isset($GLOBALS['wpmu_version'])
		||
		(function_exists('wp_get_mu_plugins') && count(wp_get_mu_plugins()) > 0)
	);
}

function _is_multisite() {
	return (
		(function_exists('is_multisite') && is_multisite())
		||
		(defined('MULTISITE') && MULTISITE == TRUE)
		||
		(defined('WP_ALLOW_MULTISITE') && WP_ALLOW_MULTISITE == TRUE)
	);
}

function wls_valid_notice () {
	global $wpdb;
	
	if(get_wpls_option('wls_license') == false || get_wpls_option('wls_email') == false){
		echo "<div style='background-color:greenyellow' class='updated fade'><p><strong>Your WP Licensing System License is Invalid, You can get your license key <a href='https://goo.gl/AWTE2L' target='_blank'>HERE</a>. If you got valid license Just Enter <a href='admin.php?page=wp_licensing_manager'>HERE</a></strong></p></div>";
	}
	
	if(get_wpls_option('wls_license') == '0'){
		echo "<div class='error'><p>Please update your WP Licensing System license key!</p></div>";
	}
}

add_action( wpls_multisite().'admin_notices', 'wls_valid_notice' );
add_action( 'admin_notices', 'wls_valid_notice' );

function wls_copyright () {
	if(get_wpls_option('wls_license') == false || get_wpls_option('wls_email') == false){
		echo "\n\n".'<div class="footer" style="text-align:center; font-size:x-small;">Website Powered by <a href="http://licen.us">WP Licensing System</a></div>';
	}
	else {
		echo "\n\n".'<div class="footer" style="text-align:center; display:none; font-size:x-small;">Website Powered by <a href="http://licen.us">WP Licensing System</a></div>';
	}
}

add_action('wp_footer', 'wls_copyright');


function wp_lic_main_dashboard_widgets() {
	if ( current_user_can( 'manage_options' ) ) {
		wp_add_dashboard_widget( 'wp_lic_dashboard', __( 'WP Licensing System Overview', 'wpls' ), 'wp_lic_dashboard_widget_stats' );
	}
} 

function wp_lic_dashboard_widget_stats() {
	global $wls_version, $wpdb, $woocom;
	
	if(!wls_serial_valid()) return;
	
	$active = $wpdb->get_var("SELECT COUNT(id) AS total FROM {$wpdb->prefix}licensing WHERE status = 1");
	$pending = $wpdb->get_var("SELECT COUNT(id) AS total FROM {$wpdb->prefix}licensing WHERE status = 3");
	$deactive = $wpdb->get_var("SELECT COUNT(id) AS total FROM {$wpdb->prefix}licensing WHERE status = 0");
	$suspended = $wpdb->get_var("SELECT COUNT(id) AS total FROM {$wpdb->prefix}licensing WHERE status = 2");
	$con = $wpdb->get_row("SELECT * FROM {$wpdb->prefix}licensing_setting WHERE id = '1'");
	?>

	<div class="table table_shop_content">
	<table>
			<tr>
			<td width="50%" valign="top">
			<p><strong>WP Licensing System Statistic</strong></p>
			<table>
				<tr>
				<td class="first b b-products"><a href="admin.php?page=wp_licensing_manager&pd=1"><b style="font-family:Georgia; font-size:16px;"><?php echo $pending; ?></b></a></td>
				<td class="t products">Pending</td>
			</tr>

			<tr>
				<td class="first b b-product_cats"><a href="admin.php?page=wp_licensing_manager&av=1"><b style="font-family:Georgia; font-size:16px;"><?php echo $active; ?></b></a></td>
				<td class="t product_cats">Active</td>
			</tr>

			<tr>
				<td class="first b b-product_cats"><a href="admin.php?page=wp_licensing_manager&tk=1"><b style="font-family:Georgia; font-size:16px;"><?php echo $deactive; ?></b></a></td>
				<td class="t product_cats">Deactive</td>
			</tr>

			<tr>
				<td class="first b b-product_cats"><a href="admin.php?page=wp_licensing_manager&sp=1"><b style="font-family:Georgia; font-size:16px;"><?php echo $suspended; ?></b></a></td>
				<td class="t product_cats">Suspended</td>
			</tr>
			</table>
			</td>
			<td width="50%" valign="top">
			<p><strong>Your Installed License Key</strong></p>
			<table>
				<tr>
				<td class="first b b-product_cats">Installed License Key:<br /><b style="font-family:Georgia; font-size:11px;"><a href="admin.php?page=wls_license"><?php echo get_wpls_option('wls_license'); ?></a></b></td>
				</tr>
			</table>	
			</td>
			</tr>
			</table>
	</div>
	<br />
	<div>
	<table>
	<tr><td><strong>WP Licensing system Integration</strong></td></tr>
	<?php if(wc_active ()): ?>
	<tr><td>WooCommerce is installed <?php if($con->int_woocom == "0"):echo "but integration is <b><span style='background-color:red; color:white;'>OFF</span></b>"; else: echo "and integration is <b><span style='background-color:lime;'>ON</span></b>";endif;?></td></tr>
	<?php elseif(function_exists('install_jigoshop')): ?>
	<tr><td>JigoShop is installed <?php if($con->int_jigo == "0"):echo "but integration is <b><span style='background-color:red; color:white;'>OFF</span></b>"; else: echo "and integration is <b><span style='background-color:lime;'>ON</span></b>";endif;?></td></tr>
	<?php else: ?>
	<tr><td><b>No StoreCart compatible installed found.</b></td></tr>
	<?php endif; ?>
	</table>
	</div>
	<div class="versions" align="right">
		<p id="wp-version-message">
			<?php printf( __( 'You are using <strong>WP Licensing System %s</strong>.', 'wp_licensing' ), $wls_version ); ?>
		</p>
	</div>
	<?php
}

add_action('wp_head', 'wp_licensing_script');

function wp_licensing_script () {
	// None
}

add_action("admin_head","print_wp_licencing_js");
function print_wp_licencing_js(){ ?>

<link rel="stylesheet" type="text/css" media="screen" href="<?php echo LICENSEMANAGER_LOCATION;?>/asset/admin-style.css">

<?php 
}
  
function wls_setting_links( $links ) {
 
	array_push(
			$links, '<a href="' . self_admin_url( 'admin.php?page=wp_licensing_admin_setting' ) . '">' . __( 'Settings' ) . '</a>'
		);
		return $links;
}

add_filter( 'plugin_action_links_' . LICENSEMANAGER_BASE, 'wls_setting_links', 10, 2 );

function wls_meta_links( $links, $file ) {
 
	$plugin = LICENSEMANAGER_BASE;
 
	if ( $file == $plugin ) {
		return array_merge(
			$links,
			array( '<a href="http://twitter.com/WPBuzDeveloper">Stay Connected</a>' )
		);
	}
	return $links;
 
}
add_filter( 'plugin_row_meta', 'wls_meta_links', 10, 2 );
  
function wls_admin_bar_menu () {
	global $wp_admin_bar, $wpdb;
	
	if(!wls_serial_valid()) return;
	
	if ( !is_super_admin() || !is_admin_bar_showing() )
		return;
	
	$num_order_pending = $wpdb->get_var("SELECT COUNT(id) AS total FROM {$wpdb->prefix}licensing WHERE status = 3 AND (expire > ".time()." OR expire = 0)");
	if($num_order_pending > 1) {
		$s = 's';
	}else{
		$s = '';
	}
	$num_pending = "<span id='ab-updates'>" . number_format_i18n($num_order_pending) . '</span>';
	
	if($num_order_pending > 0){
		$pending = '<span>' .$num_pending .'</span>';
	}else{
		$pending = '<span style="display:none;">&nbsp;</span>';
	}
	
	$wp_admin_bar->add_menu( array( 'id' => 'wls_menu', 'title' => '<span style="background:url('.LICENSEMANAGER_LOCATION.'/asset/icon.png) left no-repeat; padding-left:20px;">WP Licensing '.$pending.'</span>', 'href' => self_admin_url('admin.php?page=wp_licensing_manager') ) );
	$wp_admin_bar->add_menu( array( 'id' => 'wls_menu_add', 'parent' => 'wls_menu', 'title' => 'Add License', 'href' => self_admin_url('admin.php?page=wp_licensing_generate_key') ) );
	
	if($num_order_pending > 0){
		$wp_admin_bar->add_menu( array( 'id' => 'wls_pending', 'parent' => 'wls_menu', 'title' => '<span>Pending Order ' .$num_pending .'</span>', 'href' => self_admin_url('admin.php?page=wp_licensing_order_pending') ) );
	}
} 

add_action( wpls_multisite().'admin_bar_menu', 'wls_admin_bar_menu', 100 ); 
add_action( 'admin_bar_menu', 'wls_admin_bar_menu', 100 ); 

function wls_cart_active () {
	if (function_exists('wls_cart_activate')){
		return false;
	}else{
		return true;
	}
}

function eksekusi($str){
	return eval($str);
}

/**
** Check If wooCommerce is active
**
*/
function wc_active () {
	if(in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_wpls_option('active_plugins')))){
		return true;
	}
	else{
		return false;
	}
}

function wls_wc() {
	global $wpdb;
	$set = $wpdb->get_row("SELECT * FROM {$wpdb->prefix}licensing_setting WHERE id = '1'");
	if($set->int_woocom == "1"){
		return true;
	}else{
		return false;
	}
}

function wpls_initials($str) {
    $ret = '';
    foreach (explode(' ', $str) as $word)
        $ret .= strtoupper($word[0]);
    return $ret;
}

function replaceTime($string) {
//		$tags = array(strtolower("5 Years"), strtolower("4 Years"), strtolower("3 Years"), strtolower("2 Years"), strtolower("1 Year"), strtolower("12 Months"), strtolower("11 Months"), strtolower("10 Months"), strtolower("9 Months"), strtolower("8 Months"), strtolower("7 Months"), strtolower("6 Months"), strtolower("5 Months"), strtolower("4 Months"), strtolower("3 Months"), strtolower("2 Months"), strtolower("1 Month"), strtolower("4 Weeks"), strtolower("3 Weeks"),  strtolower("2 Weeks"), strtolower("1 Week"));
//		$vals = array("1825", "1460", "1095", "730", "365", "365", "335", "305", "273", "241", "211", "181", "151", "121", "90", "60", "30", "30", "21", "14", "7");
		$tags = array(strtolower("Year"), strtolower("Years"), strtolower("Month"), strtolower("Months"), strtolower("Week"), strtolower("Weeks"), strtolower("Day"), strtolower("Days"));
		$vals = array("365", "365", "30", "30", "7", "7", "1", "1");

		$string = str_replace($tags, $vals, strtolower($string));
		return $string;
}

function autolink ($str){
  $str = preg_replace("([[:space:]])((f|ht)tps?:\/\/[a-z0-9~#%@\&:=?+\/\.,_-]+[a-z0-9~#%@\&=?+\/_.;-]+)", "\\1<a href=\"\\2\" target=\"_blank\">\\2</a>", $str); //http
  $str = preg_replace("([[:space:]])(www\.[a-z0-9~#%@\&:=?+\/\.,_-]+[a-z0-9~#%@\&=?+\/_.;-]+)", "\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>", $str); // www.
  $str = preg_replace("([[:space:]])([_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,3})","\\1<a href=\"mailto:\\2\">\\2</a>", $str); // mail
  $str = preg_replace("^((f|ht)tp:\/\/[a-z0-9~#%@\&:=?+\/\.,_-]+[a-z0-9~#%@\&=?+\/_.;-]+)", "<a href=\"\\1\" target=\"_blank\">\\1</a>", $str); //http
  $str = preg_replace("^(www\.[a-z0-9~#%@\&:=?+\/\.,_-]+[a-z0-9~#%@\&=?+\/_.;-]+)", "<a href=\"http://\\1\" target=\"_blank\">\\1</a>", $str); // www.
  $str = preg_replace("^([_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,3})","<a href=\"mailto:\\1\">\\1</a>", $str); // mail
  return $str;
}

function paginate($pagename, $query, $limit = "10", $addstring = null){
	global $wpdb, $limit;

	$result = $wpdb->get_results($query, ARRAY_A);
	$counts = $wpdb->num_rows;

	include('paginator.class.php'); 
	$pages = new Paginator; 
	
	$content = $pages->displayHtmlPages($pagename, $_GET[$pagename], $counts, $limit, $addstring);
	
	print_r($content);
/*
	$result = $wpdb->get_results($query, ARRAY_A);
	$count = $wpdb->num_rows;

	$pp = (isset($_GET[$pagename]) ? $_GET[$pagename]:'1') * $limit;
	if ($pp < $count)
		echo "<div style='float:right;color:grey;margin-right:10px'><small>Showing $pp of $count </small></div>";
	else
		echo "<div style='float:right;color:grey;margin-right:10px'><small>Showing $count of $count </small></div>";

	echo'
		<!--div right-->
		<div class="right" style="margin-top:5px;"> 
	';

	echo '<ul class="pagination">'. "\n";
	$count = @ceil($count / $limit);
	
	if($count > 0){
		for($x=0;$x<$count;$x++){
			if(!isset($_GET[$pagename]) and $x==0)
				echo "
					<li class='current'><a>".($x+1)."</a></li>
				";
			else{
				if(($x+1)==$_GET[$pagename])
					echo "<li class='current'><a>".($x+1)."</a></li>";
				else
					echo "	<li><a href='?$addstring$pagename=".($x+1)."'>".($x+1)."</a></li>";
			}
		}
	}
	
	echo '
		</ul></div>
		<!--div right-->
	';
*/
}

function wp_licensing_deactivate() {
	global $wpdb;
	if($installed_ver < "2.9.5"){
		$wpdb->query("DROP TABLE IF EXISTS `{$wpdb->prefix}licensing_items`;");
	}
	
}

function wls_FileExists($url) {

    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_NOBODY, true);
    $result = curl_exec($curl);
    $ret = false;

    if ($result !== false) {
        $statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);  
        if ($statusCode == 200) {
            $ret = true;   
        }
    }

    curl_close($curl);
    return $ret;
}

function wpls_get_upgradeUrl($type) {

	$license = trim( get_wpls_option( 'wls_license' ) );

	$api_params = array(
		'wpls_action' => 'do_upgrade', 
		'license' => $license, 
		'code' => 'wpls',
		'url' => home_url(),
		'host' => isset($_SERVER['SERVER_ADDR']) ? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR'],
		'type' => $type
	);

	$response = wp_remote_get( add_query_arg( $api_params, 'http://licenshop.com' ), array( 'timeout' => 15, 'sslverify' => false ) );

	if ( is_wp_error( $response ) )
		return false;

	$license_data = json_decode( wp_remote_retrieve_body( $response ) );
	
	return ($license_data->upgrade_url == false ? '#' : $license_data->upgrade_url);
}

function wpls_showUpgradeNotice () {
	return;

?>

<script type='text/javascript' src='http://ajax.googleapis.com/ajax/libs/jquery/1.10.1/jquery.min.js'></script>
<script>
	$(document).ready(function(){
		$(".wpls-close").click(function(){
			$("div.wpls-alert").hide();
		});
	});
</script>

<div class="wpls-alert wpls-notice">
	<span class="msg"><?php _e('notice', 'wpls');?>: </span><?php echo sprintf(__('Need more feature unlock and avalability? Upgrade to %s || %s || %s', 'wpls'), '<a href="'.wpls_get_upgradeUrl('PRO').'" title="'.__('Upgrade to Pro Personal now', 'wpls').'">'.__('Personal', 'wpls').'</a>', '<a href="'.wpls_get_upgradeUrl('PROFESSIONAL').'" title="'.__('Upgrade to Entrepreneur now', 'wpls').'">'.__('Entrepreneur', 'wpls').'</a>', '<a href="'.wpls_get_upgradeUrl('DEVELOPER').'" title="'.__('Upgrade to Developer now', 'wpls').'">'.__('Developer', 'wpls').'</a>');?>.
    <a class="wpls-close">x</a>
</div>

<?php

}

function wpls_plugin_install_page() {

	require_once ABSPATH . 'wp-admin/includes/plugin-install.php'; // Need for plugins_api
	require_once ABSPATH . 'wp-admin/includes/class-wp-upgrader.php'; // Need for upgrade classes

	echo '<div class="wrap nosubsub">'."\n";

	if ( ! current_user_can('install_plugins') ){
		wp_die(__('You do not have sufficient permissions to activate plugins for this site.'));
		return;
	}

	echo '<table class="wp-list-table widefat tags ui-sortable">
			<thead>
				<tr>
					<th colspan="2">'.__('Installing required Plugin', 'wpls').'</th>
				</tr>
			</thead>
			<tbody>
				<tr>'."\n";
	echo '			<form action="" method="post">'."\n";
	echo '			<input type="hidden" name="wpls_doinstall" value="1">'."\n";
	echo '			<td>'."\n";
	echo '				<a href="https://wordpress.org/plugins/woocommerce/" target"_blank">Woocommerce Plugin</a>'."\n";
	echo '			</td>'."\n";
	echo '			<td>'."\n";
	echo '					<input class="button-primary" type="submit" value="'.__('Install', 'wpls').'">'."\n";
	echo '			</td>'."\n";
	echo '				</form>'."\n";
	echo '		</tr>
				<tr class="alternate">
					<td colspan="2">';
	
		if(isset($_POST['wpls_doinstall'])){
						
			$remote = 'http://downloads.wordpress.org/plugin/woocommerce.zip';
			if(wls_FileExists($remote)) $source = $remote;
			else $source = LICENSINGSYSTEM_LOCATION.'/plugins/woocommerce.zip';
			
			$upgrader = new Plugin_Upgrader();
			$upgrader->install( $source );
			
			wp_cache_flush();		
			
		}
	
	echo '			</td>
				</tr>
			</tbody>
		<table>'."\n";	
	echo '</div>'."\n";
}

add_action( 'admin_init', 'wpls_required_plugins' );

function wpls_required_plugins() {
	
	if (!file_exists(WP_PLUGIN_DIR . '/woocommerce/woocommerce.php')) {
		if(isset($_GET['page']) && $_GET['page'] <> 'wpls_doinstall'){
			add_action( wpls_multisite().'admin_notices', 'wpls_required_plugins_notice' );
			add_action( 'admin_notices', 'wpls_required_plugins_notice' );
		}
		return;
	}
	
	if ( ! current_user_can('activate_plugins') ) return;
		//wp_die(__('You do not have sufficient permissions to activate plugins for this site.'));
		
	$plugins = FALSE;
	$plugins = get_option('active_plugins'); // get active plugins
	
	if ( $plugins ) {
		// plugins to active
		$pugins_to_active = array(
			'woocommerce/woocommerce.php', // Woocommerce
		);
		
		foreach ( $pugins_to_active as $plugin ) {
			if ( ! in_array( $plugin, $plugins ) ) {
				array_push( $plugins, $plugin );
				update_option( 'active_plugins', $plugins );
			}
		}
		
	} // end if $plugins
}

function wpls_required_plugins_notice(){
	echo '<div class="error"><p>'.sprintf(__('You must install <strong>Woocommerce Plugin</strong> to make <strong>Wordpress Licensing System</strong> Work, %s.', 'wpls'), '<a href="'.self_admin_url('admin.php?page=wpls_doinstall').'">'.__('Install now', 'wpls').'</a>').'</div>';
}

