<?php
/*
*
* Licensing System Plugin WordPress
* It doesn't work witout Licensing System Installed On your Wordpress Blog
* File Name: api.php
* All Right reserved by law, You're not authorized to modified, edit, or distribute without right!
* (c) WPDeveloper, CV. 2013
*
*/

if (!defined('ABSPATH')){
    header("HTTP/1.0 404 Not Found");
    exit('<h1>Not Found</h1>The requested URL '.$_SERVER['SCRIPT_NAME'].' was not found on this server.'); //Exit if accessed directly
}

add_action ('init', 'wpls_license_jsonp_request', -1);
function wpls_license_jsonp_request(){
    global $wpdb;

    if(isset($_REQUEST['callback']) && !empty($_REQUEST['action'])){
        header("Content-Type: application/javascript; application/json");

        $calback = $_REQUEST['callback'];

        // pull the match email from post data
		$email = ( !empty($_REQUEST['email']) ) ? $_REQUEST['email'] : '';

        // pull the match key from post data
        $licensekey =  ( !empty($_REQUEST['wpls-verify']) ) ? $_REQUEST['wpls-verify'] : '';
        $licensekey =  ( !empty($licensekey) ) ? $licensekey : $_REQUEST['wpls-key'];

		// pull the match string from match data
		$domain = ( !empty($_REQUEST['domain']) ) ? $_REQUEST['domain'] : 'http://localhost';
		$domain = str_ireplace('www.', '', parse_url($domain, PHP_URL_HOST));

		// pull the match string from product data
		$product = ( !empty($_REQUEST['product']) ) ? $_REQUEST['product'] : '';
		$product = ( !empty($product) ) ? $product : $_REQUEST['pid'];
		$product = ( !empty($product) ) ? $product : 'none';

		// pull the match string from IP data
		$validip = ( !empty($_REQUEST['validip']) ) ? $_REQUEST['validip'] : NULL;

		// pull the match string from Directory data
		$validdir = ( !empty($_REQUEST['validdir']) ) ? $_REQUEST['validdir'] : NULL;

		// set action request
		$action = ( !empty($_REQUEST['action']) ) ? $_REQUEST['action'] : 'validate';

    	// check if we got a key
		if( !empty($licensekey) && !empty($email) ){

			$sql = "SELECT * FROM {$wpdb->prefix}licensing WHERE license = '{$licensekey}'";
			$lic_result = $wpdb->get_results($sql);
			$lic_data = $wpdb->get_row($sql);

			if($is_debug){
				echo '<pre>';
				var_dump($lic_result);
				echo '</pre>';
				exit();
			}

			$valid = wpls_auth($licensekey, $product, $email, $validip, $action);

			if( $valid ) {

				$object = $wpdb->get_row($sql);

				$status = NULL;
				if($object->status == '0') $status = __('Deactive', 'wpls');
					if($object->status == '1') $status = __('Active', 'wpls');
						if($object->status == '2') $status = __('Suspended', 'wpls');
							if($object->status == '3') $status = __('Pending', 'wpls');

				if($object->expire == '0') $date = __('Lifetime', 'wpls');
					else  $date = date("Y/m/d", $object->expire);

                if( $object->expire != '0' && $object->expire < time() ){
                    $status = __('Expired', 'wpls');
                }

				if($object->product != NULL && wc_active ()){

					$_product = wc_get_product($object->product);
					$product_data = array(
						'id' => $object->product,
						'name' => $_product->name,
						'price' => $_product->price
					);

					// will available soon
					$downloads = array();
					list($wc, $order_id) = explode('-', $object->order_id);
					if( isset($order_id) && ('wc' == strtolower($wc)) ){
						$order = new WC_Order( $order_id );
						if($order->get_order_number()){
							foreach ( $_product->get_downloads() as $file_id => $file ) {
								$downloads[$file_id] = add_query_arg( array('product' => $object->product, 'order_id' => $order_id, 'wpls-download' => $file_id), home_url( '/' ) );
							}
							if ( $_product->is_downloadable() && !empty($downloads) )
								$product_data['file'] = $downloads;
						}
					}
				}
				else $product_data = $object->product;

				$data['valid']  = true;
				$data['info']['id'] = $object->id;
				$data['info']['domain']  = ($object->domain == NULL) ? NULL : str_replace('|', ', ', $object->domain);
				$data['info']['expire'] = ($object->expire == NULL) ? NULL : $date;
                $data['info']['expire_string'] = ($object->expire == NULL) ? NULL : $object->expire;
				$data['info']['status']  = ($object->status == NULL) ? NULL : $status;
				$data['info']['product'] = ($object->product == NULL) ? NULL : $product_data;
				$data['info']['message'] = "Congratulation, your license is valid and active!";

			}
			else {

				$data['valid']  = false;
				$data['info']['domain']  = NULL;
				$data['info']['expire'] = NULL;
				$data['info']['status']  = NULL;
				$data['info']['message'] = "Error, your license is invalid!";

			}
		}
		else{

			$data['valid']  = false;
			$data['info']['message'] = "Error, your license is invalid!";

		}

		$data['generator']['name']  = "Wordpress Licensing System Basic";
		$data['generator']['version']  = get_wpls_option('wls_version');
		$data['generator']['status']  = wls_serial_valid() ? __("Licensed") : __("Unlicensed");

		$hasil = json_encode($data, JSON_PRETTY_PRINT);

        echo $calback . "(" . $hasil . ")";
        die();
    }
}

add_action( 'template_redirect', 'wpls_license_verifier', -1);
function wpls_license_verifier () {
	global $wpdb, $wp_query;

    if(isset($_REQUEST['wpls-verify']) || isset($_REQUEST['wpls-key'])){

        // pull the match email from post data
		$email = ( !empty($_REQUEST['email']) ) ? $_REQUEST['email'] : '';

		// pull the match key from post data
		$licensekey =  ( !empty($_REQUEST['wpls-verify']) ) ? $_REQUEST['wpls-verify'] : '';
		$licensekey =  ( !empty($licensekey) ) ? $licensekey : $_REQUEST['wpls-key'];

		// pull the match string from match data
		$domain = ( !empty($_REQUEST['domain']) ) ? $_REQUEST['domain'] : 'http://localhost';
		$domain = str_ireplace('www.', '', parse_url($domain, PHP_URL_HOST));

		// pull the match string from product data
		$product = ( !empty($_REQUEST['product']) ) ? $_REQUEST['product'] : '';
		$product = ( !empty($product) ) ? $product : $_REQUEST['pid'];
		$product = ( !empty($product) ) ? $product : 'none';

		// pull the match string from IP data
		$validip = ( !empty($_REQUEST['validip']) ) ? $_REQUEST['validip'] : NULL;

		// pull the match string from Directory data
		$validdir = ( !empty($_REQUEST['validdir']) ) ? $_REQUEST['validdir'] : NULL;

		// set action request
		$action = ( !empty($_REQUEST['action']) ) ? $_REQUEST['action'] : 'validate';

		// set is_debug request
		$is_debug = ( !empty($_REQUEST['debug']) && $_REQUEST['debug'] == 1 ) ? true : false;

		//is envato product
		$is_envato = ( !empty($_REQUEST['envato_item']) && $_REQUEST['envato_item'] == 'yes' ) ? true : false;

		//output type
		$format = ( isset($_REQUEST['type']) ) ? $_REQUEST['type'] : 'json';

		//version to check
		$old_version = ( isset($_REQUEST['old_version']) ) ? $_REQUEST['old_version'] : '1';

		// check if we got a key
		if( !empty($licensekey) && !empty($email) ){

			if($action == 'check-version'){
				$hasil = wpls_check_version( $licensekey, $product, $domain, $old_version, $format );
				echo $hasil;
				die();
			}

			if( $is_envato ){
				$hasil = envato_purchase_verification( $licensekey, $product, $domain, $format );
				echo $hasil;
				die();
			}

			$sql = "SELECT * FROM {$wpdb->prefix}licensing WHERE license = '{$licensekey}'";
			$lic_result = $wpdb->get_results($sql);
			$lic_data = $wpdb->get_row($sql);

			if($is_debug){
				echo '<pre>';
				var_dump($lic_result);
				echo '</pre>';
				exit();
			}
			
			$valid = wpls_auth($licensekey, $product, $domain, $validip, $action);
			if( $valid ) {

				$object = $wpdb->get_row($sql);

				$is_wc_order = (stripos($object->order_id, 'WC') !== false) ? true : false;
				$status = 'Invalid';
				$is_valid = true;
				
				if($object->status == '0') $status = __('Deactive', 'wpls');
					if($object->status == '1') $status = __('Active', 'wpls');
						if($object->status == '2') $status = __('Suspended', 'wpls');
							if($object->status == '3') $status = __('Pending', 'wpls');

				if($object->expire == '0') $date = __('Lifetime', 'wpls');
					else  $date = date("Y/m/d", $object->expire);

                if( $object->expire != '0' && $object->expire < time() ){
                    $status = __('Expired', 'wpls');
                }

				if( $is_wc_order ){
					$order_id = str_replace("WC-", "", $object->order_id);
					$order = wc_get_order( $order_id );
					$user_email = $order->get_billing_email();					
					if($user_email != $email){
						$status = 'Invalid';
						$is_valid = false;
					}
				}

				if($object->product != NULL && wc_active ()){

					$_product = wc_get_product($object->product);
					$product_data = array(
						'id' => $object->product,
						'name' => $_product->name,
						'price' => $_product->price
					);

					// will available soon
					$downloads = array();
					list($wc, $order_id) = explode('-', $object->order_id);
					if( isset($order_id) && ('wc' == strtolower($wc)) && $is_valid ){
						$order = new WC_Order( $order_id );
						if($order->get_order_number()){
							foreach ( $_product->get_downloads() as $file_id => $file ) {
								$downloads[$file_id] = add_query_arg( array('product' => $object->product, 'order_id' => $order_id, 'wpls-download' => $file_id), home_url( '/' ) );
							}
							if ( $_product->is_downloadable() && !empty($downloads) )
								$product_data['file'] = $downloads;
						}
					}
				}
				else $product_data = $object->product;

				$data['valid']  = $is_valid;
				$data['info']['id'] = $object->id;
				$data['info']['domain']  = ($object->domain == NULL) ? NULL : str_replace('|', ', ', $object->domain);
				$data['info']['expire'] = ($object->expire == NULL) ? NULL : $date;
				$data['info']['status']  = ($object->status == NULL) ? 'Invalid' : $status;
				$data['info']['product'] = ($object->product == NULL) ? NULL : $product_data;
				$data['info']['message'] = $is_valid ? __("Congratulation, your license is valid and active!", 'wpls') : __("Error, your license is invalid!", 'wpls');

			}
			else {

				$data['valid']  = false;
				$data['info']['domain']  = NULL;
				$data['info']['expire'] = NULL;
				$data['info']['status']  = 'Invalid';
				$data['info']['message'] = __("Error, your license is invalid!", 'wpls');

			}
		}
		else{

			$data['valid']  = false;
			$data['info']['message'] = __("Error, your license is invalid!", 'wpls');

		}

		$data['generator']['name']  = "Wordpress Licensing System Basic";
		$data['generator']['version']  = get_wpls_option('wls_version');
		$data['generator']['status']  = wls_serial_valid() ? __("Licensed") : __("Unlicensed");

		$hasil = json_encode($data, JSON_PRETTY_PRINT);

		if(isset($_REQUEST['type'])){
			if($_REQUEST['type'] == 'xml'){
				header('Content-type: application/xml');
				echo wpls_toxml($data, 'wpls_data');
			}
			else {
				header('Content-type: application/json');
				echo $hasil;
			}
		}
		else {
			header('Content-type: application/json');
            echo $hasil;
		}

		exit();
	}
}

function wpls_auth($licensekey, $product, $domain, $validip = '', $action = 'validate'){ // Open Fucntion auth
	global $wpdb;

    $sql = "SELECT * FROM {$wpdb->prefix}licensing WHERE license = '".$licensekey."' AND status = '1'";
	$query = $wpdb->query($sql);
	$count = $wpdb->get_results($sql);
    $data = $wpdb->get_row($sql);

    //create_log( print_r($data, 1) );

    if(count($count) > 0 ){
		$data = $wpdb->get_row($sql);

		if($data->mproduct == 'yes'){
			$valid = wpls_singleauth($licensekey, $domain, $validip, $action);

			if($valid)
				return TRUE;
		}
		else {
			$item = get_post( $data->product );

			if( !$item ) return false;
			
			$product_code = get_post_meta($data->product, 'wpls_code', true);
			if($item->post_parent != 0)
				$product_code = get_post_meta($item->post_parent, 'wpls_code', true);

			error_log(print_r($product_code, 1));

			if($product == $product_code){
				$valid = wpls_singleauth($licensekey, $domain, $validip, $action);
				if($valid)
					return TRUE;
			}

			return FALSE;
		}
	}

	return FALSE;

} // Close Function auth

function wpls_singleauth($licensekey, $domain, $validip = '', $action = 'validate'){ // Open Fucntion singleauth
	global $wpdb;

	$sql = "SELECT * FROM {$wpdb->prefix}licensing WHERE license = '".$licensekey."' AND status = '1'";
	$query = $wpdb->query($sql);
	$count = $wpdb->get_results($sql);

	if( count($count) > 0 ) {

		$rows = $wpdb->get_row($sql);

		if( ( $rows->expire < time() ) && ($rows->expire != 0) ){ // check if license key is expired, "0" is indicate is lifetime
			return FALSE;
		}
		else {
			if($rows->allowed == "0"){ // check if license allowed to use for unlimited domain

				$validdomains = explode("|", str_replace(' ', '', $rows->domain));
				$validips =  explode("|", str_replace(' ', '', $rows->validip));

				$validdomains = is_array($validdomains) ? $validdomains : array(); // make sure is format in array
				$validips = is_array($validips) ? $validips : array(); // make sure is format in array

				$validdomains = array_filter($validdomains); // make sure all empty array is removed
				$validips = array_filter($validips); // make sure all empty array is removed

				if(!in_array( $domain, $validdomains )){
					$validdomains[] = $domain;
					$validips[] = $validip;

					$addomain = implode("|", $validdomains);
					$addip = implode("|", $validips);

					$wpdb->query("UPDATE `{$wpdb->prefix}licensing` SET `domain` = '".$addomain."', `validip` = '".$addip."' WHERE `license` = '".$licensekey."'");
				}

				return TRUE;
			}
			else {

				if($rows->allowed == "1"){ // check if license only use for single domain

					if($action == 'activate'){
						if(empty($rows->domain)){ // check if domain already registered or not
							$activate = $wpdb->query("UPDATE `{$wpdb->prefix}licensing` SET `domain` = '".$domain."', `validip` = '".$validip."' WHERE `license` = '".$licensekey."'");
							if( $activate ) return TRUE;

						}
					}

					if( $domain == trim($rows->domain) ){ // check if domain is authorized to use license
						if($action == 'deactivate'){
							$deactivate = $wpdb->query("UPDATE `{$wpdb->prefix}licensing` SET `domain` = '', `validip` = '' WHERE `license` = '".$licensekey."'");
							if( !$deactivate ) return FALSE;
						}

						return TRUE;
					}

					return FALSE;

				}
				else {

					$validdomains = explode("|", str_replace(' ', '', $rows->domain));
					$validips =  explode("|", str_replace(' ', '', $rows->validip));

					$validdomains = is_array($validdomains) ? $validdomains : array(); // make sure is format in array
					$validips = is_array($validips) ? $validips : array(); // make sure is format in array

					$validdomains = array_filter($validdomains); // make sure all empty array is removed
					$validips = array_filter($validips); // make sure all empty array is removed

					if(in_array( $domain, $validdomains )){ // check if domain is authorized to use license
						if($action == 'deactivate'){
							foreach($validdomains as $registered){
								if($registered == $domain){
									$del = $registered;
									break;
								}
							}

							foreach($validips as $registeredip){
								if($registeredip == $validip){
									$delip = $registeredip;
									break;
								}
							}

							$validdomains = array_diff($validdomains, array($del) );
							$validips = array_diff($validips, array($delip) );

							$dedomain = implode("|", $validdomains);
							$dedip = implode("|", $validips);
							$deactivate = $wpdb->query("UPDATE `{$wpdb->prefix}licensing` SET `domain` = '".$dedomain."', `validip` = '".$dedip."' WHERE `license` = '".$licensekey."'");
							if( !$deactivate ) return FALSE;
						}

						return TRUE;
					}
					else {

						if($rows->allowed != "1"){ // check if license is not for single domain

							$count_domain = count($validdomains);
							$count_ip = count($validips);
							$count_x = $rows->allowed;// - 1; // is must be same value with higher value of array

							if($action == 'activate'){
								if( $count_domain < $count_x ){
									$validdomains[] = $domain;
									$validips[] = $validip;

									$addomain = implode("|", $validdomains);
									$addip = implode("|", $validips);

									$activate = $wpdb->query("UPDATE `{$wpdb->prefix}licensing` SET `domain` = '".$addomain."', `validip` = '".$addip."' WHERE `license` = '".$licensekey."'");
									if( $activate ) return TRUE;
								}
							}
						}

						return FALSE;
					}
				}
			}
		}
	}
	else {
		return FALSE;
	}
} // Close Function singleauth

function wpls_toxml($data, $rootNodeName = 'data', $xml=null){ // Open function toxml

	// turn off compatibility mode as simple xml throws a wobbly if you don't.
	if (ini_get('zend.ze1_compatibility_mode') == 1){
		ini_set ('zend.ze1_compatibility_mode', 0);
	}

	// check if we are in a recursion
	if ($xml == null){
		// we are not, so add a header
		$xml = simplexml_load_string("<?xml version='1.0' encoding='utf-8'?><$rootNodeName />");
	}

	// loop through the data passed in.
	foreach($data as $key => $value){
		// no numeric keys in our xml
		if (is_numeric($key)){
			// make string key...
			$key = "unknownNode_". (string) $key;
		}

		// replace anything not alpha numeric
		$key = preg_replace('/[^a-z0-9\-\_\.\:]/i', '', $key);

		// if there is another array found recrusively call this function
		if (is_array($value)){
			$node = $xml->addChild($key);
			// recrusive call.
			wpls_toxml($value, $rootNodeName, $node);
		}
		else {
			// add single node.
			$value = htmlentities($value);
			$xml->addChild($key, $value);
		}
	}
	// pass back as string
	return $xml->asXML();

} // close Function toxml

add_action( 'template_redirect', 'wpls_dodownload', 999);
function wpls_dodownload(){
	if( isset($_REQUEST['wpls-download']) && !empty($_REQUEST['product']) && !empty($_REQUEST['order_id']) ){
		$order_id = $_REQUEST['order_id'];
		$product_id = $_REQUEST['product'];
		$file_id = $_REQUEST['wpls-download'];
		$order = new WC_Order( $order_id );

		if( $order ){
			$generate_download = wpls_generate_wc_download($order_id, $product_id, $order->billing_email);
			if($generate_download){
				wp_redirect($generate_download[$file_id], 301);
			}
			else{
				new WP_Error('not_found');
				wp_die(__('Not found'));
			}
		}
		else{
			new WP_Error('not_found');
			wp_die(__('Not found'));
		}
	}
}

function envato_purchase_verification( $code, $product_code, $domain, $format = 'json' ){
	global $wpdb;

	require_once( LICENSEMANAGER_ENVATO . '/marketplaces.php');
	$e = new Envato_marketplaces();
	$e->set_api_key( get_wpls_option('envato_lic_key') );

	$data = array();

	$vp = $e->verify_purchase( get_wpls_option('envato_lic_user'), $code );
	if (isset($vp->buyer)){
		$data['valid']  = true;

		$sql = "SELECT * FROM {$wpdb->prefix}licensing WHERE license = '{$code}'";
		$lic_result = $wpdb->get_results($sql);
		if( count($lic_result) < 1 ) {
			$product = get_wpls_product( $product_code );
			$orderid = 'envato-' . $code;
			$invoice = 'inv-' . $code;

			$create_key = $wpdb->query("INSERT INTO {$wpdb->prefix}licensing SET add_on = '".time()."', license = '{$code}', product = '{$product->ID}', order_id = '{$orderid}', expire = '0', status = '1', allowed = '1', pro_code = '{$product_code}', invoice = '{$invoice}', mproduct = 'no', `domain` = '{$domain}'");

		}

		$object = $object->get_row($sql);
		if($object->expire == '0') $date = __('Lifetime', 'wpls');
			else  $date = date("Y/m/d", $object->expire);

		$data['info'] = array(
				'id' 		=> $object->id,
				'domain'	=> ($object->domain == NULL) ? NULL : str_replace('|', ', ', $object->domain),
				'expire'	=> ($object->expire == NULL) ? NULL : $date,
				'status'	=> ($object->status == NULL) ? NULL : __('Active', 'wpls'),
				'product'	=> ($object->product == NULL) ? NULL : $vp,
				'message'	=> __("Congratulation, your license is valid and active!", 'wpls')
			);
	}
	else {

		$data['valid']  = false;
		$data['info'] = array(
				'id'		=> NULL,
				'domain'	=> NULL,
				'expire'	=> NULL,
				'status'	=> NULL,
				'message'	=> __("Error, your license is invalid!", 'wpls')
			);
	}

	$data['generator'] = array(
			'name'		=> "Wordpress Licensing System Basic",
			'version'	=> get_wpls_option('wls_version'),
			'status'	=> wls_serial_valid() ? __("Licensed", 'wpls') : __("Unlicensed", 'wpls'),
		);

	$hasil = json_encode($data, JSON_PRETTY_PRINT);

	if( 'xml' == $format){
		header('Content-type: application/xml');
		return wpls_toxml($data, 'wpls_data');
	}
	else {
		header('Content-type: application/json');
		return $hasil;
	}
}

function wpls_check_version( $code, $product, $domain, $old_version, $format = 'json' ){
	global $wpdb;

	$data = array();
	$valid = wpls_auth($code, $product, $domain);
	if($valid){
		$args = array(
			'post_status' => 'publish',
			'posts_per_page' => 1,
			'post_type' => 'updater',
			'meta_query' => array(
				array(
					'key' => 'product',
					'value' => $product,
					'compare' => '=',
				),
				array(
					'key' => 'old_version',
					'value' => $old_version,
					'compare' => '=',
				),
			)
		);

		$updaters = get_posts( $args );
		$post = $updaters[0];
		$item = get_post( get_post_meta( $post->ID, 'product', true ) );
		$data = array(
			'name'		=> $item->post_title,
			'version'	=> get_post_meta( $post->ID, 'new_version', true ),
			'download_url'	=> get_post_meta( $post->ID, 'updater_file', true ),
			'details_url'	=> get_permalink($item->ID),
			'last_updated'	=> get_post_modified_time('Y-m-d H:i:s', 'GMT', $post->ID),
			'sections'	=> array(
				'description' => $item->post_content,
				'changelog'	=> $post->post_content
			)
		);
	}

	$hasil = json_encode($data, JSON_PRETTY_PRINT);
	if( 'xml' == $format){
		header('Content-type: application/xml');
		return wpls_toxml($data, 'wpls_data');
	}
	else {
		header('Content-type: application/json');
		return $hasil;
	}

}

function get_wpls_product( $item_id ){
	$args = array(
		'post_type' => 'product',
		'post_status' => 'publish',
		'numberposts' => -1,
		'meta_query'  => array(
			array(
				'key' => 'wpls_code',
				'value' => $item_id,
				'compare' => '=',
			),
		),
	);

	$product = get_posts( $args );
	return $product[0];
}

if(!function_exists('create_log')){
    function create_log( $message, $success = true, $end = false ){
        if (!file_exists('log.txt')) {
            file_put_contents('log.txt', 'Site Logs'."\r\n");
        }

        $text = "[".date( "m/d/Y g:i A" )."] - ".( $success ? "SUCCESS :" : "FAILURE :" ).$message."\n";

        if ( $end ){
            $text .= "\n------------------------------------------------------------------\n\n";
        }

        $debug_log_file_name = 'log.txt';
        $fp = fopen( $debug_log_file_name, "a" );
        fwrite( $fp, $text );
        fclose( $fp );
    }
}

?>
