<?php

class Paginator{
    public $current_page = 1;
    public $num_pages;
    public $return;
    public $mid_range = 3;
    public $items_per_page = 25;
    public $items_total = 0;
    public $data = array();
    
    
    /**
     * the constructer
     */
    public function __construct() {
    }
    
    private function paginate($pagename = 'pg', $page = 1, $items_total = 0, $limit = 25, $addstring = null) {
        //$this->num_pages = ceil($items_total/$this->items_per_page);
		$this->num_pages = ceil($items_total/$limit);
        $this->current_page = (isset($page) && $page > 0 && $page <= $this->num_pages) ? (int) $page : 1 ; // must be numeric > 0
        $prev_page = $this->current_page-1;
        $next_page = $this->current_page+1;
        
        $this->data['totalRows'] = $items_total;
        $this->data['totalPages'] = $this->num_pages;
        $this->data['results'] = $this->items_total;
        $this->data['previous'] = $prev_page;
        $this->data['current'] = $this->current_page;

        $this->data['next'] =  $next_page;
        $this->data['last'] = $this->num_pages;
        
		$this->return = '<ul class="wpls_pagination wpls_paginationC wpls_paginationC01">'."\r\n";
        
		if($this->num_pages > 10) {
            $this->return .= ($this->current_page > 1 && $items_total >= 10) ? "<li><a href=\"?$addstring$pagename=$prev_page\">&laquo; Previous</a></li>\r\n":"";
            
            $this->start_range = $this->current_page - floor($this->mid_range/2);
            $this->end_range = $this->current_page + floor($this->mid_range/2);

            if($this->start_range <= 0) {
                $this->end_range += abs($this->start_range)+1;
                $this->start_range = 1;
            }
			
            if($this->end_range > $this->num_pages) {
                $this->start_range -= $this->end_range-$this->num_pages;
                $this->end_range = $this->num_pages;
            }
			
            $this->range = range($this->start_range,$this->end_range);

            for($i=1;$i<=$this->num_pages;$i++) {
                if($this->range[0] > 2 && $i == $this->range[0]) {
                    $this->data['pages'][] = '<li><a class="In-active" href="#">...</a></li>'."\r\n";
                    $this->return .= '<li><a class="In-active" href="#">...</a></li>'."\r\n";
                }
                
				if($i==1 || $i==$this->num_pages || in_array($i,$this->range)) {
                    $this->data['pages'][] =  $i;
                    $this->return .= ($i == $this->current_page) ? "<li><a title=\"Go to page $i of $this->num_pages\" class=\"current In-active\" href=\"#\">$i</a></li>\r\n":"<li><a title=\"Go to page $i of $this->num_pages\" href=\"?$addstring$pagename=$i\">$i</a></li>\r\n";
                }
				
                if($this->range[$this->mid_range-1] < $this->num_pages-1 && $i == $this->range[$this->mid_range-1]) {    
                    $this->data['pages'][] = '<li><a class="In-active" href="#">...</a></li>'."\r\n";
                    $this->return .= '<li><a class="In-active" href="#">...</a></li>'."\r\n";
                }
            }
            $this->return .= (($this->current_page < $this->num_pages && $items_total >= 10) And ($page != 'All') And $this->current_page > 0) ? "<li><a href=\"?$addstring$pagename=$next_page\">Next &raquo;</a></li>\r\n":"";
            
        }
        else {
            for($i=1;$i<=$this->num_pages;$i++) {
                $this->data['pages'][] = $i; 
                $this->return .= ($i == $this->current_page) ? "<li><a class=\"current In-active\" href=\"#\">$i</a></li>\r\n":"<li><a href=\"?$addstring$pagename=$i\">$i</a></li>\r\n";
            }
        }
		
		$this->return .= "</ul>\r\n";
    }
	
    /**
     * Returns the string that is the result of the paginator
     */
    public function displayHtmlPages($pagename = 'pg', $page = 1, $items_total = 0, $limit = 10, $addstring = null) {
        $this->paginate($pagename, $page, $items_total, $limit, $addstring);
        return $this->return;
    }
	
    /**
     * Returns an array paginator data
     */
    public function getPaginateData( $pagename = 'pg', $page = 1, $items_total = 0, $limit = 10, $addstring = null ) {
        $this->paginate($pagename, $page, $items_total, $limit, $addstring);
        return $this->data;
    }
}