<?php
/*
	Plugin Name: Wordpress Licensing System Basic
	Plugin URI: http://www.licenshop.com
	Description: Wordpress Licensing system plugin to help you manage your distributed script with key keys.
	Author: 20script
	Version: 3.0.4
	Author URI: http://www.20script.ir
	License: GPL v2
*/

if (!defined('ABSPATH'))
	exit('<h1>Not Found</h1>The requested URL ' . $_SERVER['SCRIPT_NAME'] . ' was not found on this server . '); //Exit if accessed directly

//error_reporting(E_ALL);
//ini_set('display_errors', 0);

define('LICENSEMANAGER_NAME', 'Wordpress Licensing System Basic');
define('LICENSEMANAGER_VERSION', '3.0.4');
define('LICENSEMANAGER_URI', 'http://noor.my.id');

define('LICENSEMANAGER_LOCATION', WP_PLUGIN_URL . '/'.basename(dirname(__FILE__)));
define('LICENSEMANAGER_PATH', plugin_dir_path(__FILE__));
define('LICENSEMANAGER_BASE', plugin_basename( __FILE__ ));
define('LICENSEMANAGER_RELPATH', dirname( plugin_basename( __FILE__ ) ) );
define('ADMIN_PANEL', site_url() . '/wp-admin/');
define('LICENSEMANAGER_AUTHPATH', plugin_dir_path( __FILE__ ) . 'auth' );
define('LICENSEMANAGER_ENVATO', plugin_dir_path( __FILE__ ) . 'envato' );
define('LICENSEMANAGER_JS', plugin_dir_path( __FILE__ ) . 'jigoshop' );
define('LICENSEMANAGER_SHORTCODE', plugin_dir_path( __FILE__ ) . 'shortcodes' );
define('LICENSEMANAGER_UPDATE', plugin_dir_path( __FILE__ ) . 'plugin_update' );
define('LICENSEMANAGER_WC', plugin_dir_path( __FILE__ ) . 'woocommerce' );
define('LICENSEMANAGER_DOC', plugin_dir_path( __FILE__ ) . 'documentation' );
define('LICENSEMANAGER_HOST', '' );

if ( ! function_exists( 'is_plugin_active_for_network' ) ) {
	require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
}

if (is_plugin_active_for_network( LICENSEMANAGER_BASE )) {
	define("WPLS_NETWORK_ACTIVATED", true);
}
else {
	define("WPLS_NETWORK_ACTIVATED", false);
}
require(LICENSEMANAGER_AUTHPATH . '/multisite.class.php');

if(!is_writable(LICENSEMANAGER_UPDATE)){
	echo "<div class='error'><p>".LICENSEMANAGER_UPDATE." is not writable!</p></div>";
}

$wls_version = get_wpls_option('wls_version');
$limit = "10";

require(LICENSEMANAGER_AUTHPATH . '/_hook_.php');
require(LICENSEMANAGER_AUTHPATH . '/about.php');
require(LICENSEMANAGER_AUTHPATH . '/api.php');
require(LICENSEMANAGER_AUTHPATH . '/generate.class.php');
require(LICENSEMANAGER_AUTHPATH . '/license.conf.php');
require(LICENSEMANAGER_AUTHPATH . '/license-conf.class.php');
require(LICENSEMANAGER_AUTHPATH . '/license-manager.class.php');
require(LICENSEMANAGER_AUTHPATH . '/order.class.php');
require(LICENSEMANAGER_AUTHPATH . '/order.stats.php');
require(LICENSEMANAGER_AUTHPATH . '/product.php');
require(LICENSEMANAGER_AUTHPATH . '/woocommerce.class.php');
require(LICENSEMANAGER_SHORTCODE . '/all-in-one.php');
require(LICENSEMANAGER_SHORTCODE . '/check.class.php');
require(LICENSEMANAGER_SHORTCODE . '/envato.class.php');
require(LICENSEMANAGER_SHORTCODE . '/eStore.class.php');
require(LICENSEMANAGER_UPDATE . '/update_notifier.php');

register_activation_hook(__FILE__, 'wp_licensing_activation_hook');
register_deactivation_hook(__FILE__, 'wp_licensing_deactivation_hook');

function wp_licensing_activation_hook (){
	//wp_licensing_install();
}
		update_wpls_option('wls_license', 'valid');
		update_wpls_option('wls_email', 'valid@mail.com');
		update_wpls_option('wls_allow_pr', 10);
		update_wpls_option('wls_allow_lc', 250);
		update_wpls_option('wpls_authorized_status', true);
function wp_licensing_deactivation_hook (){
	wp_licensing_deactivate();
}

if(_is_wpmu()){
	add_action(wpls_multisite() . 'admin_notices', '_admin_notices_wpmu', 1);
	add_action('admin_notices', '_admin_notices_wpmu', 1);
}
elseif(_is_multisite()){
	//add_action('admin_notices', '_admin_notices_multisites', 1);
}

$userip = isset($_SERVER['SERVER_ADDR']) ? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR']; 
$basicData = array('wpls_action' => 'get_version',"license" => get_wpls_option('wls_license'), "code" => "wpls", "url" => $_SERVER['SERVER_NAME'], "host" => $userip, 'cc' => 'yes', 'email' => get_wpls_option('wls_email'));

require (LICENSEMANAGER_UPDATE . '/plugin-update-checker.php');
$WlsUpdateChecker = new PluginUpdateChecker( add_query_arg( $basicData, "http://licen.us/envato/update.php"), __FILE__, 'wp-licensing-sys' );

$localizationDomain = "wpls";
$locale = get_locale();
$mo = dirname(__FILE__) . "/languages/" . $localizationDomain . "-".$locale.".mo";
load_textdomain($localizationDomain, $mo);

function get_wpls_version() {
	if ( ! function_exists( 'get_plugins' ) )
		require_once( ABSPATH . 'wp-admin/includes/plugin.php' );

	$wpls_folder = get_plugins( '/' . plugin_basename( dirname( __FILE__ ) ) );
	$wpls_file = basename( ( __FILE__ ) );
	return $wpls_folder[$wpls_file]['Version'];
}

add_action(wpls_multisite() . 'admin_notices', 'wpls_version_compare');
add_action('admin_notices', 'wpls_version_compare');
function wpls_version_compare () {
	if(get_wpls_option('wls_version') < get_wpls_version()) {
		echo '<div class="error"><p>Your Wordpress Licensing System is not setup correctly, press button bellow to setup it.<br /><form method="post" action=""><input type="hidden" name="wpls_action" value="install"><input type="submit" class="button button-primary" value="Setup now!"></form></p></div>';
	}
}

function wpls_multisite() {
	$wplsnetwork = is_multisite() ? 'network_' : '';
	return $wplsnetwork;
}

?>